<?php

define('IN_COPPERMINE', true);

require('include/init.inc.php');
pageheader("Upload stats for:");


//Activity Graph Function
function activityGraph($cellName, $tableName, $title, $barTile, $notCtime=false)
{
	starttable(705, $title, 1);
	$query = "SELECT $cellName FROM $tableName";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);
	$uploadTimes = array();
	$total = 0;
	foreach($rowset as $row)
	{
		if($notCtime)
		{
			//Get hours from date/time string
			$split1 = explode(' ', $row[0]);
			$split2 = explode(':', $split1[1]);
			$hour = $split2[0];		
		}
		else
		{
			$hour = strftime("%H",$row[0]);
		}
		switch($hour)
		{
			case '00':
			$index = 0;
			break;
			case '01':
			$index = 1;
			break;
			case '02':
			$index = 2;
			break;
			case '03':
			$index = 3;
			break;
			case '04':
			$index = 4;
			break;
			case '05':
			$index = 5;
			break;
			case '06':
			$index = 6;
			break;
			case '07':
			$index = 7;
			break;
			case '08':
			$index = 8;
			break;
			case '09':
			$index = 9;
			break;
			default:
			$index = $hour;
		}
		$uploadTimes[$index] = @$uploadTimes[$index] + 1;
		$total++;
	}
	
	ksort($uploadTimes, SORT_NUMERIC);
	
	print('<tr><td align="center" colspan="26"><b>Time of Day (GMT'.$CONFIG['time_offset'].')</b></td></tr>');
	print('<tr><td align="center" colspan="26" height="2"></td></tr>');
	print('<tr><td align="center" colspan="26" height="2" bgcolor="#000000"></td></tr>');
	print('<tr><td align="center" colspan="26" height="1"></td></tr>');
	print('<tr><td height="100" width="1" valign="bottom"><img src="images/spacer.gif" width="1" height="200" /></td>');
	for($i = '0'; $i <= '23'; $i++)
	{
		if(isset($uploadTimes[$i]))
		{
			print('<td height="100" width="4%" valign="bottom" align="center" style="font-size: 80%">'.round($uploadTimes[$i]/$total*'100',0).'%<br /><img src="'.$barTile.'" border="1" alt="" width="15" height="'.round($uploadTimes[$i]/$total*'200',0).'" /></td>');
		}
		else
		{
			print('<td height="100" width="4%"></td>');
		}
	}
	print('<td height="100" width="1" valign="bottom"><img src="images/spacer.gif" width="1" height="200" /></td></tr>');
	print('<tr><td align="center" colspan="26" height="1"></td></tr>');
	print('<tr><td align="center" colspan="26" height="2" bgcolor="#000000"></td></tr>');
	print('<tr><td align="center" colspan="26" height="1"></td></tr>');
	print('<tr><td></td>');
	for($i = '0'; $i <= '23'; $i++)
	{
		#if(isset($uploadTimes[$i]))
		#{
		#	print('<td width="15">'.$i.' ('.round($uploadTimes[$i]/$total*'200',0).'%)</td>');
		#}
		#else
		#{
			print('<td width="4%" align="center">'.$i.'</td>');
		#}
	}
	print('<td></td></tr>');
	
	endtable();
}


//Start Most Commented
starttable("705", "Most Commented Images", 1);
$query = "SELECT pid FROM {$CONFIG['TABLE_COMMENTS']}";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$index = $row[0];
	$mostCommented[$index] = @$mostCommented[$index] + 1;
}

arsort($mostCommented, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostCommented),0,4) as $image)
{
	$query = "SELECT filepath, filename, owner_name, owner_id FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.pid = '$image' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;

	print("<a href=\"displayimage.php?pos=-$image\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostCommented[$image]} Comments</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End Most Commented


//Start Most Voted
starttable("705", "Most Voted on Images", 1);
$query = "SELECT pid, votes FROM {$CONFIG['TABLE_PICTURES']}";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$mostVoted[$row[0]] = $row[1];
}

arsort($mostVoted, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostVoted),0,4) as $image)
{
	$query = "SELECT filepath, filename, owner_name, owner_id FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.pid = '$image' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;

	print("<a href=\"displayimage.php?pos=-$image\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostVoted[$image]} Votes</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End Most Voted


//Start Most Viewed
starttable("705", "Most Viewed Images", 1);
$query = "SELECT pid, hits FROM {$CONFIG['TABLE_PICTURES']}";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$mostViewed[$row[0]] = $row[1];
}

arsort($mostViewed, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostViewed),0,4) as $image)
{
	$query = "SELECT filepath, filename, owner_name, owner_id FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.pid = '$image' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;

	print("<a href=\"displayimage.php?pos=-$image\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostViewed[$image]} Views</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End Most Viewed



//Start User Most Commented
starttable("705", "Most Commented Users", 1);
$query = "SELECT owner_id FROM {$CONFIG['TABLE_COMMENTS']} as c, {$CONFIG['TABLE_PICTURES']} as p WHERE c.pid = p.pid";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$index = $row[0];
	$mostCommentedUser[$index] = @$mostCommentedUser[$index] + 1;
}

arsort($mostCommentedUser, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostCommentedUser),0,4) as $user)
{
	$query = "SELECT filepath, filename, owner_name, owner_id, pid FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.owner_id = '$user' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;
	
	$cat = explode('/', $file[0]);
	
	print("<a href=\"index.php?cat={$cat[1]}\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostCommentedUser[$user]} Comments</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End User Most Commented


//Start User Most Voted
starttable("705", "Most Voted on Users", 1);
$query = "SELECT owner_id, votes FROM {$CONFIG['TABLE_PICTURES']}";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$mostVotedUser[$row[0]] = @$mostVotedUser[$row[0]] + $row[1];
}

arsort($mostVotedUser, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostVotedUser),0,4) as $user)
{
	$query = "SELECT filepath, filename, owner_name, owner_id, pid FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.owner_id = '$user' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;
	
	$cat = explode('/', $file[0]);
	
	print("<a href=\"index.php?cat={$cat[1]}\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostVotedUser[$user]} Votes</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End User Most Voted


//Start User Most Viewed
starttable("705", "Most Viewed Users", 1);
$query = "SELECT owner_id, hits FROM {$CONFIG['TABLE_PICTURES']}";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$mostViewedUser[$row[0]] = @$mostViewedUser[$row[0]] + $row[1];
}

arsort($mostViewedUser, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostViewedUser),0,4) as $user)
{
	$query = "SELECT filepath, filename, owner_name, owner_id FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.owner_id = '$user' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;
	
	$cat = explode('/', $file[0]);
	
	print("<a href=\"index.php?cat={$cat[1]}\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostViewedUser[$user]} Views</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End User Most Viewed



//Start User Most Commenting
starttable("705", "Top Commenters", 1);
$query = "SELECT author_id FROM {$CONFIG['TABLE_COMMENTS']} as c, {$CONFIG['TABLE_PICTURES']} as p WHERE c.pid = p.pid";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$index = $row[0];
	$mostCommentingUser[$index] = @$mostCommentingUser[$index] + 1;
}

arsort($mostCommentingUser, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostCommentingUser),0,4) as $user)
{
	$query = "SELECT filepath, filename, owner_name, owner_id, pid FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.owner_id = '$user' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;
	
	$cat = explode('/', $file[0]);
	
	print("<a href=\"index.php?cat={$cat[1]}\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostCommentingUser[$user]} Comments</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End User Most Commenting




//Start Album Most Commented
starttable("705", "Most Commented Album", 1);
$query = "SELECT aid FROM {$CONFIG['TABLE_COMMENTS']} as c, {$CONFIG['TABLE_PICTURES']} as p WHERE c.pid = p.pid";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$index = $row[0];
	$mostCommentedAlbum[$index] = @$mostCommentedAlbum[$index] + 1;
}

arsort($mostCommentedAlbum, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostCommentedAlbum),0,4) as $album)
{
	$query = "SELECT filepath, filename, owner_name, owner_id, pid FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.aid = '$album' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;
		
	print("<a href=\"thumbnails.php?album=$album\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostCommentedAlbum[$album]} Comments</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End Album Most Commented


//Start Album Most Voted
starttable("705", "Most Voted on Album", 1);
$query = "SELECT aid, votes FROM {$CONFIG['TABLE_PICTURES']}";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$mostVotedAlbum[$row[0]] = @$mostVotedAlbum[$row[0]] + $row[1];
}

arsort($mostVotedAlbum, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostVotedAlbum),0,4) as $album)
{
	$query = "SELECT filepath, filename, owner_name, owner_id, pid FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.aid = '$album' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;
		
	print("<a href=\"thumbnails.php?album=$album\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostVotedAlbum[$album]} Votes</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End Album Most Voted


//Start Album Most Viewed
starttable("705", "Most Viewed Album", 1);
$query = "SELECT aid, hits FROM {$CONFIG['TABLE_PICTURES']}";
$result = cpg_db_query($query);
$rowset = cpg_db_fetch_rowset($result);
mysql_free_result($result);

foreach($rowset as $row)
{
	$mostViewedAlbum[$row[0]] = @$mostViewedAlbum[$row[0]] + $row[1];
}

arsort($mostViewedAlbum, SORT_NUMERIC);
echo <<<EOT
<table width="685" height="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="FFFFFF" class="sTableB">
<tr>
EOT;
foreach(array_slice(array_keys($mostViewedAlbum),0,4) as $album)
{
	$query = "SELECT filepath, filename, owner_name, owner_id FROM {$CONFIG['TABLE_PICTURES']} as p WHERE p.aid = '$album' ";
	$result = cpg_db_query($query);
	$rowset = cpg_db_fetch_rowset($result);
	mysql_free_result($result);

	$file = $rowset[0];

	echo <<<EOT
        <td valign="top" class="thumbnails" width ="160" align="center">
                <table width="160" border="0" cellpadding="0" cellspacing="0">
                        <tr>
                                <td align="center" width ="160">
EOT;
		
	print("<a href=\"thumbnails.php?album=$album\"><img src=\"albums/" . $file[0] . 'thumb_' . $file[1] . "\" class=\"image\" border=\"0\" alt=\"\" /></a><br /><a href =\"profile.php?uid={$file[3]}\">{$file[2]}</a><span class=\"thumb_caption\">{$mostViewedAlbum[$album]} Views</span>");

	echo <<<EOT
                                </td>
                        </tr>
                </table>
        </td>
EOT;


}

endtable();
//End Album Most Viewed


//Start Upload Activity By Time	
activityGraph("ctime", $CONFIG['TABLE_PICTURES'], "Upload Activity By Time", "images/siteLayout/Contentpanel_Sidebar_05.gif");
//End Upload Activity By Time	

//Start Comment Activity By Time	
activityGraph("msg_date", $CONFIG['TABLE_COMMENTS'], "Comment Posting By Time", "images/siteLayout/Contentpanel_Sidebar_05.gif", true);
//End Comment Activity By Time	

//Start Vote Activity By Time
activityGraph("vote_time", $CONFIG['TABLE_VOTES'], "Voting Activity By Time", "images/siteLayout/Contentpanel_Sidebar_05.gif");
//End Vote Activity By Time	

//Start Viewing Activity By Time
activityGraph("sdate", $CONFIG['TABLE_HIT_STATS'], "Viewing Activity By Time", "images/siteLayout/Contentpanel_Sidebar_05.gif");
//End Viewing Activity By Time	


pagefooter();

$signature = 'Coppermine Photo Gallery ' . COPPERMINE_VERSION . ' ('. COPPERMINE_VERSION_STATUS . ')';

?>
